<?php 
namespace CrivionAtEnvato;

class Popup extends WPML_AutoDetectRedirect_by_IP {

	public function __construct(  ) {}

	// do the dew! show popup after <head></head> loaded
	public static function detectCountry(  ) {

		global $sitepress;

		// define current language set ( from WPML, of course! )
		$lang = ICL_LANGUAGE_CODE;

		// keep it for "no thanks"
		$initial_language = $lang;

		 // get language mappings
		$mappings = get_option( parent::$option_name );

		if( !$mappings ) return;

		if(isset($_GET['clear'])) {
			unset($_SESSION['wpml-audotect-redirect-session']);
		}

		if(isset($_GET['geodebug'])) {
			ob_end_clean();
			echo parent::$visitorCountry;
			echo '<br/>';
			echo parent::$visitorIPAddress;
			echo '<pre>';
			print_r($_SESSION);
			echo '</pre>';

			if( isset( $mappings[ parent::$visitorCountry ] ) ) {

				$mappedLanguage = $mappings[ parent::$visitorCountry ];

				$wpmlP = get_permalink(  );
				$wpml_permalink = apply_filters( 'wpml_permalink', $wpmlP, $mappedLanguage ); 

				echo 'get_permalink: ' . $wpmlP . '<br/>';
				echo 'wpml_computed_permalink: ' . $wpml_permalink . '<br/>';
				echo '<a href="?clear=session">Clear Session (See Redirect Again)</a>';

			}

			exit;
		} 

		// find mapping for current visitor's country
		if( isset( $mappings[ parent::$visitorCountry ] ) ) {

			// check which language is mapped for this country 
			$mappedLanguage = $mappings[ parent::$visitorCountry ];

			// if mapped language is different than currently set language -> offer a switch popup
			if( $mappedLanguage != $lang ) {

				// switch to user country language get translated strings in the popup.
				$sitepress->switch_lang( $mappedLanguage );

				// set current request URI
				$page = trim( strip_tags( $_SERVER[ 'REQUEST_URI' ] ) );
				$uritogo = preg_replace('#^/[a-z]{2}/#i', $mappedLanguage . '/', $page);
				$languageSuggestionURL = get_option('siteurl') . '/' . $mappedLanguage;	
					
				$wpmlP = get_permalink(  );
				$wpml_permalink = apply_filters( 'wpml_permalink', $wpmlP, $mappedLanguage ); 
				
				echo self::showSweetAlert( $wpml_permalink );

				// switch back to original language to let user decide
				$sitepress->switch_lang( $initial_language );
			}
		}

	}

	// sweeeeet alert!
	public static function showSweetAlert( $url ) {

		// don't show popup if visitor clicked "No, thanks!"
		if( isset( $_SESSION[ 'wpml-audotect-redirect-session' ] ) )
			return '<script>console.log("WPML_AutoDetectRedirect_by_IP: SESSION_SKIP, User previously clicked \"No Thanks\". Not showing popup!");</script>';

		// do the redirect right away if option is so!
		if( get_option( 'wpml-autodetect-action', 'popup' ) == 'redirect' ) {

			// set the session so he can switch language as he wants after!
			$_SESSION[ 'wpml-audotect-redirect-session' ] = date( 'jS F Y H:i' ) . ':' . parent::$visitorIPAddress . ':' . parent::$visitorCountry;

			return '<meta http-equiv="refresh" content="0; url= '.$url.'" />';
		}

		// get country list for dropdown
	    $geoIP = new \CrivionAtEnvato\GeoIP;
	    $countryList = array_combine($geoIP->GEOIP_COUNTRY_CODES, $geoIP->GEOIP_COUNTRY_NAMES);
	    asort($countryList);
	    $countryList = array_filter($countryList);

	    $sweetalert = '<script>jQuery(function($) {';

		// set popup options
		$title = str_replace("{COUNTRY}", $countryList[parent::$visitorCountry], get_option('crv-wpml-dr-popup-title', 'Hello {COUNTRY}'));
		$text = get_option('crv-wpml-dr-popup-text', 'Set your text in wp-admin');
		$confirmButtonText = get_option('crv-wpml-dr-confirm-text', 'set in wp-admin');
		$confirmButtonColor = get_option('wpml-autoredirect-confirm-color', 'DD6B55');
		$cancelButtonText = get_option('crv-wpml-dr-cancel-text', 'set in wp-admin');
		

		$sweetalert .= 'swal({   
				title: "'.htmlspecialchars($title).'",   
				text: "'.htmlspecialchars($text).'",  
				imageUrl: "'.parent::$plugin_dir_url.'/static/svg-flags/'.strtolower(parent::$visitorCountry).'.svg" ,
				showCancelButton: true,   
				confirmButtonColor: "#'.$confirmButtonColor.'",   
				confirmButtonText: "'.htmlspecialchars($confirmButtonText).'",   
				cancelButtonText: "'.htmlspecialchars($cancelButtonText).'",   
				closeOnConfirm: false, 
				closeOnCancel: false
				}, 
				function(isConfirm){   
					if (isConfirm) {     
						document.location.href="'.$url.'";
					} else {     
						$.post( wpmldetectredirectajax.ajax_url, { "set":"session", "action": "wpmlAutoDetectRedirect" }, function(response) {
							console.log( response );
							swal.close();
						});
					}
				});';

		$sweetalert .= '});</script>';

		return $sweetalert;

	}

}